#include "DFontGL.h"
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <string>
#ifdef WIN32
#  include <windows.h>
#endif
#include <GL/GL.h>

bool checkUsage(string const & param) {
	//return param.find_first_of(".") != string::npos;
  return false;
	}

//#define DEBUG_TEXTURES

int main (int argc, char ** argv) 
{
  SDL_Surface * screen;
  SDL_Event event;
  if (argc == 1 || checkUsage(argv[1])) {
	cerr << "Usage " << argv[0] << " fontname (no extension)\nExample:\n\t" <<
argv[0] << " Font\n";
	exit (-1);
	}
  string file = argv[1];  
  
  string file1 = file+".png";
  string file2 = file+".dat";

  SDL_Init(SDL_INIT_VIDEO);
  SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
  screen = SDL_SetVideoMode(640, 480, 32, SDL_OPENGL);
  
  DFontGL fnt(file1.c_str(), file2.c_str(), 640, 480);

  while (event.type != SDL_MOUSEBUTTONDOWN) {
    glClear(GL_COLOR_BUFFER_BIT);

    glClearColor(1, 0, 0, 0);
#ifdef DEBUG_TEXTURES
    fnt.prepareState();
    int x = 0;
    int y = 0;
    for (int i = 0 ; i < fnt.textures.size() ; i++) {
      if (y + fnt.textures[i].surface->h > screen->h) {
        x += fnt.textures[0].surface->w + 1;
        y = 0;
      }
      fnt.textures[i].bind();
      glBegin(GL_QUADS);
      glTexCoord2f(0, 0);
      glVertex2i(x, y);
      glTexCoord2f(1, 0);
      glVertex2i(x + fnt.textures[i].surface->w, y);
      glTexCoord2f(1, 1);
      glVertex2i(x + fnt.textures[i].surface->w, y + (fnt.textures[i].surface->h - 1));
      glTexCoord2f(0, 1);
      glVertex2i(x, y + (fnt.textures[i].surface->h - 1));
      glEnd();
      y += fnt.textures[i].surface->h;
    }
    fnt.restoreState();
#else
    glColor3f(0, 0, 0);
    fnt.PutString(0, 0, "!\"#$%&`()*+'-./0123456789:;<=>?`ABCD");
    fnt.PutString(0, fnt.CharHeight(),"EFGHIJKLMNOPQRSTUVWXYZ[\\]^_`ab");
    fnt.PutString(0, fnt.CharHeight()*2,"cdefghijklmnopqrstuvwxyz{|}~");
    for (int i(0); fnt.CharHeight()*(i+3) < 480 - fnt.CharHeight(); ++i)
      fnt.PutInt(CTR_HORIZ, fnt.CharHeight()*(i+3), i);
#endif

    SDL_GL_SwapBuffers();

    SDL_PollEvent(&event);
  }
  
  SDL_Quit();
  return 0;
}
